/****************************************************************************/
/**    Kernel-AX25-Treiber fr GNOM.                                       **/
/**  Copyright (C) 1997 Jochen Sarrazin, DG6VJ. All righs reserved.        **/
/**                                                                        **/
/**  Globale Variablen und Deklarationen                                   **/
/****************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <signal.h>
#include <linux/un.h>
#include <syslog.h>
#include <sys/ioctl.h>
#include <sys/stat.h>


#define DRIVER_NAME "kax25"		/* Maximum 10 Bytes */
#define DRIVER_VERSION "0.9"		/* Maximum 4 Bytes (eg 0.1b)*/
#define DRIVER_AUTHOR "DG6VJ"		/* Maximum 10 Bytes */

#define PROTOCOL_VERSION 2		/* Welche Protokoll-Version benutzen wir hier? */

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif



/* Wieviele QSOs sind maximal mglich? */
#define MAX_QSOs 255


/* aus kax25.conf */
char socket_path[100];
char use_ports[100];
char no_gnom_text[500];


typedef unsigned char uchar;



typedef struct _s_listen
{
  struct _s_listen *next;
  int fd;
  char call[10];
} s_listen;


/* Informationen ber den gewhlten Kernel-AX25-Port */
typedef struct _s_portinfo
{
  struct _s_portinfo *next;
  char *name;
  char *addr;
  char *desc;
  char *dev;
  int baud;
  int fd;
  
  /* Infos fr die ctl-Geschichte */
  int t1;
  int t2;
  int t3;
  int idle;
  int n2;
  int window;
  int paclen;
  
  /* Auf welche Rufzeichen soll gehrt werden? */
  s_listen *listen;
} s_portinfo;
s_portinfo *portsroot;


/* Verkettete Liste mit Frames, die emfpangen wurden whrend GNOM
 * nicht lief.
 */
typedef struct _s_saveframe
{
  struct _s_saveframe *next;
  int len;
  char *data;
} s_saveframe;


/* Informationen ber QSOs, die dieser Port verwaltet */
typedef struct
{
  int fd;
  char call[10];
  char mycall[10];
  char ax_call[10];			/* Immer mit SSID, auch wenn -0! */
  char ax_mycall[10];			/* Immer mit SSID, auch wenn -0! */
  char *digis;
  s_portinfo *port;
  
  /* Wenn GNOM nicht luft, werden hier empfangene Frames gespeichert. */
  s_saveframe *saveframe;
  s_saveframe *sendframe;
  
  int status;
  int tries;
  int squeue;
  int unack;
  
  int old;
  int wantframes;			/* Wollen wir an GNOM Frames schicken? */
} s_qsoinfo;
s_qsoinfo *qso[MAX_QSOs];


int sockfd;				/* socket-fd */
int gnomfd;				/* fd zu GNOM hin */
char anzports;				/* Wieviele Ports sind "angeschlossen"? */
int maxfd;

/* MONITOR */
int monifd;				/* FD zur Monitor-Instanz vom Kernel */
#define proto ETH_P_ALL			/* Was soll alles gemonitort werden? ETH_P_ALL = alles,
                                         * ETH_P_AX25 nur die AX25-Frames, die empfangen wurden. */



/* allgemeine Treiber-Informationen */
typedef struct
{
  char name[11];
  char version[5];
  char autor[11];
  int comm_version;
} s_driver_infos_overall;
s_driver_infos_overall driver_infos_overall;



/* Infos zu jedem Port */
typedef struct
{
  char port[10];
  char desc[20];
  int baud;
} s_driver_infos_port;



/* Defines, um 'rauszufinden, was sich gendert hat */
#define POLL_STATUS 1
#define POLL_TRIES 2
#define POLL_SQUEUE 3
#define POLL_UNACK 4


/* Diese Rufzeichen werden sofort Disconnected und nicht an GNOM weitergeleitet */
typedef struct _s_discon
{
  struct _s_discon *next;
  char *call;
} s_discon;
s_discon *discroot;




typedef struct _s_monidata
{
  struct _s_monidata *next;
  char *data;
  int len;
} s_monidata;
s_monidata *moniroot;
int monidatacount;

